--------------------以下为RobotTask矩阵处理代码-------------------
luaMatrix = {}			--处理函数矩阵
isRunMatrix = 0			--是否退出lua任务
delayTimeout = 0		--delay使用的超时时间
matrixStatusCount = 0	--矩阵状态数
currMatrixStatus = 1    --当前矩阵状态
matrixEvent = {"StateStart",			--状态启动事件
			   "KeySingleClick",		--单击事件
               "KeyMultiClick", 		--双击事件
			   "KeyLongClick", 			--长按事件
			   "IPCRecv",				--IPC接收数据事件
			   "PlayComplete",			--播放音频完成事件
			   "SpeechText",			--语音输入文本事件
			   "DelayTimeout"}			--delay超时事件

--lua处理函数矩阵主循环函数
function luaMatrixLoop()
	logLua("luaMatrixLoop---start")
	eventId = 0
	hasTimeout = 0		--是否有超时时间

	while(isRunMatrix == 1) do
		eventId = 0
		hasTimeout = 0

		--等待延时
		repeat
		    eventId, eventStr = getEvent()	--获取系统事件
			if eventId > 0 then
				hasTimeout = 0
				delayTimeout = 0			--有事件来了以后, timeout清零
			    break;
			end

			if delayTimeout == 0 then
			    break;
			end

			hasTimeout = 1			--含有超时时间

			delayTimeout = delayTimeout - 100
		until (delayTimeout < 100)

		--如果有超时时间，并且eventId为0时，则eventId=-1, 即delay超时
		if hasTimeout == 1 then
			if eventId == 0 then
				logLua("common.lua---enventId = -1")
				eventId = -1
			end
		end

		if matrixStatusCount > 0 then
			if eventId == -1 then			--delay超时事件
				logLua("common.lua---event ============-1")
				if luaMatrix[currMatrixStatus]["DelayTimeout"] ~= nil then
				    luaMatrix[currMatrixStatus]["DelayTimeout"](eventStr)
				end
			elseif eventId == -2 then		--各状态启动事件
				if luaMatrix[currMatrixStatus]["StateStart"] ~= nil then
				    luaMatrix[currMatrixStatus]["StateStart"](eventStr)
				end
			elseif eventId == 1 then		--单击按键
				if luaMatrix[currMatrixStatus]["KeySingleClick"] ~= nil then
				    luaMatrix[currMatrixStatus]["KeySingleClick"](eventStr)
				end
			elseif eventId == 2 then		--双击按键
				if luaMatrix[currMatrixStatus]["KeyMultiClick"] ~= nil then
				    luaMatrix[currMatrixStatus]["KeyMultiClick"](eventStr)
				end
			elseif eventId == 3 then		--长按按键
				if luaMatrix[currMatrixStatus]["KeyLongClick"] ~= nil then
				    luaMatrix[currMatrixStatus]["KeyLongClick"](eventStr)
				end
			elseif eventId == 4 then		--IPC接上数据事件
				if luaMatrix[currMatrixStatus]["IPCRecv"] ~= nil then
				    luaMatrix[currMatrixStatus]["IPCRecv"](eventStr)
				end
			elseif eventId == 5 then		--音频播放完成
				if luaMatrix[currMatrixStatus]["PlayComplete"] ~= nil then
				    luaMatrix[currMatrixStatus]["PlayComplete"](eventStr)
				end
			elseif eventId == 6 then		--语音输入文档事件
				if luaMatrix[currMatrixStatus]["SpeechText"] ~= nil then
				    luaMatrix[currMatrixStatus]["SpeechText"](eventStr)
				end
			end
		end
	end
end

--开始执行任务
function startMatrix()
    isRunMatrix = 1
	luaMatrixLoop()
end

--结束执行任务
function stopMatrix()
    isRunMatrix = 0
end

--设置矩阵状态
function setStatus(status)
    currMatrixStatus = status

	postEvent(status)
end

--延时
function waitEvent(timeout)
    delayTimeout = timeout
end
--------------------以下为基础接口函数----------------------------
action = ""			--动作列表
pThis = 0			--传过来LuaContainer指针

--执行脚本
function exec(ptr)
    pThis = ptr
    work()
end

--退出脚本执行
function stopTask()
	logLua("stopTask")
	stopTaskExt()
end

--开启中文语音识别
function startRecognize()
	startRecognizeExt()
end

--开启英文语音识别
function startEngRecognize()
	startEngRecognizeExt()
end

--关闭语音识别
function stopRecognize()
	stopRecognizeExt()
end

--获取语音输入
function getSpeech()
    speechText = getSpeechExt()

	return speechText
end

--获取事件输入
function getEvent()
    eventId, eventStr = getEventExt()

	return eventId, eventStr
end

--获取语音输入
function getSpeech(timeout)
	speechText = getSpeechExt(timeout)
	return speechText
end

--发送数据至apk
function sendToApk(str)
	ret = ipcSend(str)
	return ret
end

--执行动作
function execAction()
    execActions()
end

--执行动作
function execActionSync()
    execActionsSync()
end

--等待
function wait(time)
    delayMs(time)
end

--说话
function speak(content)
    action = "1#"..content
    execActions()
end

--说话
function speakSync(content)
    action = "3#"..content
    execActionSync()
end

--前进
function forward(speed, distance)
    action = "12#"..speed.."#"..distance
	execActions()
end

--后退
function fallback(speed, distance)
    action = "15#"..speed.."#"..distance
	execActions()
end

--向左转弯new
function turnLeftByTimeBySpeed(leftSpeed, rightSpeed, time)
    action = "17#"..leftSpeed.."#"..rightSpeed.."#"..time
	execActions()
end

--向右转弯new
function turnRightByTimeBySpeed(leftSpeed, rightSpeed, time)
    action = "19#"..leftSpeed.."#"..rightSpeed.."#"..time
	execActions()
end

--向左转弯new
function turnLeftBySpeedTime(leftSpeed, rightSpeed, time)
    action = "17#"..leftSpeed.."#"..rightSpeed.."#"..time
	execActions()
end

--向右转弯new
function turnRightBySpeedTime(leftSpeed, rightSpeed, time)
    action = "19#"..leftSpeed.."#"..rightSpeed.."#"..time
	execActions()
end


--向左转弯
function turnLeft(leftSpeed, rightSpeed)
    action = "17#"..leftSpeed.."#"..rightSpeed
	execActions()
end

--向右转弯
function turnRight(leftSpeed, rightSpeed)
    action = "19#"..leftSpeed.."#"..rightSpeed
	execActions()
end

--向左转弯
function turnLeft(type)
    action = "16#"..type
	execActions()
end


--向右转弯
function turnRight(type)
    action = "18#"..type
	execActions()
end

--停止
function stop()
    action = "22"
	execActions()
end

function stopBase()
    action = "22"
	execActions()
end

function stopHead()
	action = "65"
	execActoins()
end

function stopHand()
	action = "67"
	execActoins()
end

function stopMotion()
	action = "68"
	execActions()
end

--摇头
function shake(speed, times)
    action = "25#"..speed.."#"..times
	execActions()
end

--点头
function nod(speed, times)
    action = "24#"..speed.."#"..times
	execActions()
end


--左手抬起
function leftHandUp(angle, speed)
    action = "54#"..angle.."#"..speed
	execActions()
end

--左手背后
function leftHandDown(angle, speed)
    action = "55#"..angle.."#"..speed
	execActions()
end

--右手抬起
function rightHandUp(angle, speed)
    action = "56#"..angle.."#"..speed
	execActions()
end

--右手背后
function rightHandDown(angle, speed)
    action = "57#"..angle.."#"..speed
	execActions()
end


--左手摇摆
function leftHandShake(num, downangle, upangle)
    action = "58#"..num.."#"..downangle.."#"..upangle
	execActions()
end


--右手摇摆
function rightHandShake(num, downangle, upangle)
    action = "59#"..num.."#"..downangle.."#"..upangle
	execActions()
end

--双手摆动
function bothHandShake(num, downangle, upangle)
	action = "60#"..num.."#"..downangle.."#"..upangle
	execActions()
end


--原地顺时针旋转 speed angle
function clockwise_BySpeedAngle(speed, angle)
    action = "20#"..speed.."#"..angle
	execActions()
end


--原地逆时针旋转 speed angle
function clockwise_anti_BySpeedAngle(speed, angle)
    action = "21#"..speed.."#"..angle
	execActions()
end


--原地顺时针旋转bytime byspeed
function clockwise_BySpeedTime(speed, time)
    action = "61#"..speed.."#"..time
	execActions()
end


--原地逆时针旋转bytime byspeed
function clockwise_anti_BySpeedTime(speed, time)
    action = "62#"..speed.."#"..time
	execActions()
end

--原地顺时针旋转 speed angle
function clockwiseBySpeedAngle(speed, angle)
    action = "20#"..speed.."#"..angle
	execActions()
end


--原地逆时针旋转 speed angle
function anticlockwiseBySpeedAngle(speed, angle)
    action = "21#"..speed.."#"..angle
	execActions()
end


--原地顺时针旋转bytime byspeed
function clockwiseBySpeedTime(speed, time)
    action = "61#"..speed.."#"..time
	execActions()
end


--原地逆时针旋转bytime byspeed
function anticlockwiseBySpeedTime(speed, time)
    action = "62#"..speed.."#"..time
	execActions()
end


--前进(new add)(by time)
function forwardbytime(speed, time)
    action = "11#"..speed.."#"..time
	execActions()
end


--后退(new add)(by time)
function fallbackbytime(speed, time)
    action = "14#"..speed.."#"..time
	execActions()
end


--向上看
function lookUp()
    action = "27"
	execActions()
end

--向下看
function lookDown()
    action = "28"
	execActions()
end

--向左看
function lookLeft()
    action = "29"
	execActions()
end

--向右看
function lookRight()
    action = "30"
	execActions()
end

--向前看
function lookForward()
    action = "31"
	execActions()
end

--耳朵效果
function ear(mode)
    action = "40#"..mode
	execActions()
end


--情绪，动态表情
function emotion(mode)
    action = "32#"..mode
	execActions()
end

--胸灯呼吸
function bodyLEDBreath(mode)
	action = "51#"..mode
	execActions()
end

--指定颜色点亮胸灯
function bodyLEDTurnOn(color)
	action = "52#"..color
	execActions()
end

--胸灯关闭
function bodyLEDTurnOff()
	action = "53"
	execActions()
end


--播放本地音乐--默认放在/mnt/sdcard/lua/  路径下
function playAudio(path)
    action = "0#/mnt/sdcard/lua/"..path
	execActions()
end

--播放本地用户音乐--同步--默认放在/mnt/sdcard/lua/  路径下
function playAudioSync(path)
    action = "7#/mnt/sdcard/lua/"..path
	execActionsSync()
end

--播放提示音--同步
function playTone(path)
    action = "7#"..path
	execActionsSync()
end

--停止音频播放
function stopPlay()
    action = "2"
	execActionsSync()
end

--播放网络音频URL
function playUrl(path)
    action = "0#"..path
	execActions()
end

function playAudioUrlPath(urlpath)
	action = "0#"..urlpath
	execActions()
end

--改变tts合成音语速 ,speed 语速，范围[0,200],数值是百分比,数值越大 语速越慢
function set_Voice_speed(speedNum)
	set_voice_speed(speedNum)
end

--改变tts合成音语调 ,pitch 声调，范围[0,150]，数值是百分比，数值越大，语调越高
function set_Voice_pitch(pitchNum)
	set_voice_pitch(pitchNum)
end

--设置音量
function SetVolume(num)
	setVolume(num)
end
